VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Object = "{86CF1D34-0C5F-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCT2.OCX"
Begin VB.Form frmDeposits_Statement_Load 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Load Deposit Account Statement"
   ClientHeight    =   3915
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6990
   HelpContextID   =   1060
   Icon            =   "Deposit Account Load Statement.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3915
   ScaleWidth      =   6990
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin MSComCtl2.DTPicker dtpickEndDate 
      Height          =   315
      Left            =   2168
      TabIndex        =   7
      Top             =   2640
      Width           =   3735
      _ExtentX        =   6588
      _ExtentY        =   556
      _Version        =   393216
      Format          =   24510464
      CurrentDate     =   37777
   End
   Begin MSComCtl2.DTPicker dtpickStartDate 
      Height          =   315
      Left            =   2168
      TabIndex        =   6
      Top             =   2220
      Width           =   3735
      _ExtentX        =   6588
      _ExtentY        =   556
      _Version        =   393216
      Format          =   24510464
      CurrentDate     =   37777
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4478
      TabIndex        =   4
      Top             =   3240
      Width           =   1095
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2978
      TabIndex        =   3
      Top             =   3240
      Width           =   1095
   End
   Begin VB.CommandButton cmdLoad 
      Caption         =   "Load"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1418
      TabIndex        =   2
      Top             =   3240
      Width           =   1095
   End
   Begin MSFlexGridLib.MSFlexGrid grdHeader 
      Height          =   1815
      Left            =   188
      TabIndex        =   5
      Top             =   180
      Width           =   6615
      _ExtentX        =   11668
      _ExtentY        =   3201
      _Version        =   393216
      Rows            =   7
      FixedRows       =   0
      GridColor       =   0
      AllowUserResizing=   1
   End
   Begin VB.Label Label3 
      Caption         =   "Start Date"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   1088
      TabIndex        =   1
      Top             =   2280
      Width           =   3735
   End
   Begin VB.Label Label2 
      Caption         =   "End Date"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   1088
      TabIndex        =   0
      Top             =   2700
      Width           =   3735
   End
End
Attribute VB_Name = "frmDeposits_Statement_Load"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Generates a statement of account and loads it into the statement form
Option Explicit
Private Loading As Boolean


Private Sub cmdCancel_Click()
    Unload Me
End Sub


Private Sub cmdHelp_Click()
    ShowHelpTopic 1060
End Sub

Private Sub cmdLoad_Click()
    
    Dim dtmStartDate As Date
    Dim dtmEndDate As Date
    Dim strStudentID As String
    
    strStudentID = GetGridData(grdHeader, 0, 1)
    
    dtmStartDate = dtpickStartDate.Value
    dtmEndDate = dtpickEndDate.Value
    
    If Not (EndDateBeforeStartDate(dtmStartDate, dtmEndDate) _
               Or DateInTheFuture(dtmEndDate, "End Date") _
               Or InvalidStudentID(strStudentID)) Then
        Call EnterStudentDetails(dtmStartDate, dtmEndDate)
        Call EnterOpeningBalance(strStudentID, dtmStartDate)
        Call EnterStatementBody(strStudentID, dtmStartDate, dtmEndDate)
        Call EnterClosingBalance(strStudentID, dtmEndDate)
        Call EnterRowNumbers(frmDeposits_Statement_Display.grdStatementOfAccount)
        frmDeposits_Statement_Display.Show vbModal, Me
        Unload Me
    End If
        
End Sub

Private Sub EnterStudentDetails(ByVal dtmStartDate As Date, ByVal dtmEndDate As Date)
    
    Dim StatementPeriod As String
        
    'Copy details
    Call CopyGrid(frmDeposits_Statement_Display.grdHeader, grdHeader)
    
    'Enter Statement period
    StatementPeriod = Format(dtmStartDate, "dddd d mmmm yyyy") _
                    & " - " & Format(dtmEndDate, "dddd d mmmm yyyy")
    Call EnterGridData(frmDeposits_Statement_Display.grdHeader, 3, 1, StatementPeriod)
    
    
End Sub

Private Sub EnterOpeningBalance(strStudentID As String, dtmStartDate As Date)
    
    Dim HostGrid As MSFlexGrid
    Dim curOpeningBalance As Currency
    
    Set HostGrid = frmDeposits_Statement_Display.grdStatementOfAccount
    
    Call EnterGridData(HostGrid, 1, 1, Format(dtmStartDate, "dd mmm yyyy"))
    Call EnterGridData(HostGrid, 1, 2, "Opening Balance")
    
    curOpeningBalance = GetDepositOpeningBalance(strStudentID, dtmStartDate)
    Call EnterGridData(HostGrid, 1, 4, CurrencyFormat(curOpeningBalance, moneyOmitSign, moneyExcludeType))
    
    'Color red if debit. Blue otherwise
    'Note that this is not matched to the min balance
    If curOpeningBalance < 0 Then
        Call SetGridForeColor(HostGrid, 1, 4, vbRed)
    Else
        Call SetGridForeColor(HostGrid, 1, 4, vbBlue)
    End If
    
End Sub

Private Sub EnterStatementBody(strStudentID As String, ByVal dtmStartDate As Date, ByVal dtmEndDate As Date)
    
    Dim rstStatementOfAccount As Recordset
    Dim HostGrid As MSFlexGrid
    Dim FormatedAmount As String
    Dim lngRowCounter As Long
    
    'Generate Statement of account excluding balances
    qryQueryObject.SQL = GetDepositStatementBodySQL()
    qryQueryObject.Parameters("The Student") = strStudentID
    qryQueryObject.Parameters("Start Date") = dtmStartDate
    qryQueryObject.Parameters("End date") = dtmEndDate
    Set rstStatementOfAccount = qryQueryObject.OpenRecordset
    
    Set HostGrid = frmDeposits_Statement_Display.grdStatementOfAccount
    
    HostGrid.Rows = 3 + rstStatementOfAccount.RecordCount
    If rstStatementOfAccount.RecordCount > 0 Then
        rstStatementOfAccount.MoveFirst
        For lngRowCounter = 2 To rstStatementOfAccount.RecordCount + 1
            Call EnterGridData(HostGrid, lngRowCounter, 1, Format(rstStatementOfAccount("Transaction Date"), "dd mmm yyyy"))
            Call EnterGridData(HostGrid, lngRowCounter, 2, rstStatementOfAccount("Description"))
            Call EnterGridData(HostGrid, lngRowCounter, 3, rstStatementOfAccount("Reference"))
            
            
            FormatedAmount = CurrencyFormat(rstStatementOfAccount("Amount"), moneyOmitSign, moneyExcludeType)
            Call EnterGridData(HostGrid, lngRowCounter, 4, FormatedAmount)
            If rstStatementOfAccount("Amount") < 0 Then
                Call SetGridForeColor(HostGrid, lngRowCounter, 4, vbRed)
            Else
                Call SetGridForeColor(HostGrid, lngRowCounter, 4, vbBlue)
            End If
            
            rstStatementOfAccount.MoveNext
        Next
    End If
            
End Sub

Private Sub EnterClosingBalance(strStudentID As String, ByVal dtmEndDate As Date)
    
    Dim HostGrid As MSFlexGrid
    Dim curClosingBalance As Currency
    Set HostGrid = frmDeposits_Statement_Display.grdStatementOfAccount
        
    HostGrid.Row = HostGrid.Rows - 1
    
    HostGrid.Col = 1
    HostGrid.Text = Format(dtmEndDate, "dd mmm yyyy")
    
    HostGrid.Col = 2
    HostGrid.Text = "Closing Balance"
    
    HostGrid.Col = 4
    curClosingBalance = GetDepositClosingBalance(strStudentID, dtmEndDate)
    HostGrid.Text = CurrencyFormat(curClosingBalance, moneyOmitSign, moneyExcludeType)
    
    If curClosingBalance < 0 Then
        HostGrid.CellForeColor = vbRed
    Else
        HostGrid.CellForeColor = vbBlue
    End If
    
End Sub



Private Sub Form_Load()
    Loading = True
End Sub

Private Sub Form_Activate()
    Dim lngCounter As Long
    Dim objControl As Control
    
    If Loading Then
        Loading = False
        'Set Start date to 1 January of current year
        dtpickStartDate = DateSerial(Year(Date), 1, 1)
        
        'Set End Date to today's date
        dtpickEndDate = Date
        
        'Copy Student Details
        Call CopyGrid(grdHeader, frmDeposits.grdHeader)
         
    End If
            
    
End Sub

